c______________________________________________________________________
c
      subroutine cininit(msval,rmsval,nch)

!      include 'iounits.inc'
!      include '../include/datsz.inc'
!      include 'input.inc'
      use iounits_inc
      use datsz_inc
      use input_inc
      use FORMIN_common

      character*160 cfin
      character*80 ctemp,croot,cfpaths            ! TH:  change from 40 to 80
      character*3 cfn
      character*1 xtra
      logical lpath
      logical filepresent
c      lfmiss is true to fill missing values
c       cfsp, cfbr,cfdecset,cfpwset,cdirout are path/file names for
c       system params, bad recs,decset,pwset, and output file
!      common /FORMIN/irec,irecl
      

c       msval (here set equal to maxint) is missing value code
      msval = 2147483647             ! TH:  =2**31 -1
      rmsval = msval - 10000

      nmsmx = 250
      lfirst = .true.
      ioff = 0
      lfmiss = .false.
      If (l_flinp) then
         croot = flnam        ! file name is given in command line option
      else
         write(6,'(''Enter input file name: '',$)')
         read(5,'(a80)')croot
      endif
c      write(6,'(a79)')croot(1:8)
c        input file is just local name; rest of path is found from
c       file cf_paths (if cf_paths isn't in local directory, all files
c       are assumed to be in local directory)

c     changed default name for the paths file (more DOS like)

     
      lpath = .true.
c      goto 21
c     look in CF directory ...
19    continue
cew      cfpaths = 'CF\paths.cfg'                          ! changed to backslash
      cfpaths = 'paths.cfg'
      
      cfpaths = 'd:\PTA_processed\01062014\pta18\paths.cfg'

     
      open(unit=pth_unit,file=cfpaths,status='old',err=20)
      lpath = .true.
      goto 21
20    continue
cnew	and if this fails prompt the user for an alternate paths file name
      print*,'Couldn''t find the file paths.cfg. Please enter a'
      print*,'NEW NAME for the paths file or hit return and the '
      print*,'program writes output into the working directory.' 
      read(5,'(a40)') cfpaths
      if (cfpaths(1:1).eq.' ') then
         lpath = .false.
      else
         open(unit=pth_unit,file=cfpaths,status='old',err=20)
         lpath = .true.
      endif
c        data directory
 21   continue
          

ccc   mi is length of data file name with blanks stripped off
      mi = iclong(croot,80)
ccc   mr is length of "file root" -- data file name with suffix (beginging
ccc     with a dot (.) and any blanks stripped off
      mr = irlong(croot,80)

      md = 0
      if(lpath) then
         read(pth_unit,'(a80)',err = 30) ctemp
      !   read(pth_unit,'(a1)') xtra  !why this was put in is beyond me, 
                                      !it reads a whole new line BRL
         md = iclong(ctemp,80)
      end if
30    continue
      if(md.gt.0) then
cew         cfin = ctemp(1:md)//'\'//croot(1:mi)       !backslash
		 cfin = ctemp(1:md)//'\'//croot(1:mi) 
      else
         cfin = croot(1:mi)
      end if

ccc      write(0,*) 'l_NIMS = ',l_NIMS
      if(l_asc) then                                ! ascii format
         open(unit=in_unit,file=cfin,form='formatted',status='old')
         if(.not.l_clk_hd) then
ccc         need to open a clock reset file ... set name here
            if(md.gt.0) then
cew               cfclk = ctemp(1:md)//'\'//croot(1:mr)//'.clk'      ! backslash
                  cfclk = ctemp(1:md)//'\'//croot(1:mr)//'.clk'
            else
               cfclk = croot(1:mr)//'.clk'
            endif
         endif
ccc      asc_rec will read clock reset info, find nch, position file at
ccc      begining of data
         if(l_NIMS) then
            call NIMSinit(nch)
         else
            call asc_rec(nch) 
         endif
      else                             ! binary format
         if(l_NIMS) then
            open(unit=in_unit,file=cfin,form='unformatted',
     &         access='direct',recl=1,status='old')     !TH  recl4->1
            call NIMSbinInit(msval,nch)
            if(ierr_bin_read .eq. -1) then
               close(pth_unit)      
               err_file = cfin
               return
            else
               rmsval = msval-10000
cTH               if(irecl .eq. 256*nch*4) then
               if(irecl .eq. 256*nch) then                       ! word length
c              close and reopen data file for blocked reading
                  close(in_unit)
                  open(unit=in_unit,file=cfin,form='unformatted',
     &            access='direct',recl=irecl,status='old')      !TH orig: recl=irecl
                  irec = 1
               endif
            endif
         else
		 write(*,*) 'looking for weird bin files ',cfin
		 write(*,*) 'md value is ', md
!ccc         EMTF weird binary files
!ccc         open binary file and read header (to find # of data channels)
!            open(unit=in_unit,file=cfin,form='unformatted',
!     &         access='direct',recl=256,status='old')
!            call rdhd(nch)
!            close(in_unit)

!ccc      reopen binary file with correct record length
!c        integer*4 and integer*2 binary input files are supprted. 
!c        BYTES switches between
!c        the two modes and the record length is computed using BYTES.
!c        bytes is set equal to  parameter NBYTES (which is defined 
!c        in PARAMS.INC) in dnff.f unless it isn't changed with the 
!c        command line option -b ; See also rbblk
!cTH            irecl = (bytes*nblk+8)*nch+8
!            irecl = ((bytes*nblk+8)*nch+8)/4                ! recl = word length
!            open(unit=in_unit,file=cfin,form='unformatted',
!     &         access='direct',recl=irecl,status='old')

!        KMS binary format, record length in open should be RECL=1
!        initialisation of time and date

             print *,'open file:', cfin
             open(unit=in_unit,file=cfin,status='old',IOSTAT=ierr,
     &            FORM='binary' ,ACCESS='direct',RECL=1)
             irec = 0                                    ! wie bei NIMS 
    		 write(*,*) 'ierr is now', ierr
			 write(*,*) 'in_unit is ', in_unit
celw 	hardwire ierr to equal 0, see if it gets past this
celw             ierr=0
			 if (ierr /= 0) then
                 write(6,'(A,A)') 'file to open:',cfin
                 write(6,*) 'error in open KMS binary file'
                 return
             endif    
             call KMSbinInit(msval,nch1)    ! can be 6 channels
             nch = nch1
             if (nch == 6) then
                 nch = 5
             endif
!             print *,'after KMSbinInit  nch,nch1=',nch,nch1



         endif
      endif

c    system parameter directory (In all cases blank field => localdirectory)


      md = 0
      if(lpath) then
         read(pth_unit,'(a80)',err = 40) ctemp
         !read(pth_unit,'(a1)') xtra
         md = iclong(ctemp,80)
      end if
40    continue
      if(ctemp(1:8).eq.'standard') then
         cfsp='standard.sp'
      else
         if(md.gt.0) then

            cfsp = ctemp(1:md)//'\'//croot(1:mr)//'.sp'      ! backslash
celw        cfsp = ctemp(1:md)//'\'//croot(1:mr)//'.sp'      ! backslash
         else
            cfsp = croot(1:mr)//'.sp'
         end if
      end if

      md = 0
      if(lpath) then
         read(pth_unit,'(a80)',err = 50) ctemp
        ! read(pth_unit,'(a1)') xtra
         md = iclong(ctemp,80)
      end if
50    continue
      if(md.gt.0) then

         cfbr = ctemp(1:md)//'\'//croot(1:mr)//'.bad'         ! backslash
celw     cfbr = ctemp(1:md)//'\'//croot(1:mr)//'.bad'         ! backslash
      else
         cfbr = croot(1:mr)//'.bad'
      end if
       
c     decset file (full path name)
      md = 0
      if(lpath) then
         read(pth_unit,'(a80)',err = 60) cfdecset
       !  read(pth_unit,'(a1)') xtra
         md = iclong(cfdecset,80)
      end if
60    continue
      if(md.eq.0) then
         cfdecset = 'decset.cfg'
      end if

c     pwset file (full path name)
      md = 0
      if(lpath) then
         read(pth_unit,'(a80)',err = 70) cfpwset
       !  read(pth_unit,'(a1)') xtra
         md = iclong(cfpwset,80)
      end if
70    continue
      if(md.eq.0) then
         cfpwset = 'pwset.cfg'
      end if

c     output directory
      md = 0
      if(lpath) then
         read(pth_unit,'(a80)',err = 80) ctemp
c         read(pth_unit,'(a1)') xtra
         md = iclong(ctemp,80)
      end if
80    continue
        if (nch.lt.10) then
           write (cfn,'(a1,i1)') 'f',nch
           lcfn = 2
        else if (nch.ge.10) then
           write(cfn,'(a1,i2)') 'f',nch
           LCFN = 3
        endif
      if(md.gt.0) then

         cfout = ctemp(1:md)//'\'//croot(1:mr)//'.'//cfn(1:lcfn)  ! backslash
celw     cfout = ctemp(1:md)//'\'//croot(1:mr)//'.'//cfn(1:lcfn)  ! backslash
      else
         cfout = croot(1:mr)//'.'//cfn(1:lcfn)
      end if
!     read path for calibration files, default ist sensors      
c      read(pth_unit,'(a80)',IOSTAT=io_stat) ctemp
      read(pth_unit,'(a40)',IOSTAT=io_stat) ctemp
c      read(pth_unit,'(a1)') xtra
      if (io_stat .eq. 0) then
          cfrsp_path = ctemp
      else
          cfrsp_path = 'sensors'
      endif
      
      if (nch1 == 6)nch = nch1   !TH: correction for non-disabled chan 6
      close(pth_unit)
      return
      end
c______________________________________________________________________
c
      subroutine rdhd(nch)
!      include 'iounits.inc'
!      include 'input.inc'
      use iounits_inc
      use input_inc
      use FORMIN_common

      character*256 c
      character*80 comment
!      common /FORMIN/irec,irecl

c    header read routine for binary 2-byte integer cleaned data
c     files
      irec = 1
      read(in_unit,rec = irec) c
      read(c,100) cfile,nch,dr,iyr,imo,iday,ihr,imin,isec,iclk0,comment
100   format(5x,a80,5x,i2,4x,f12.4,4x,i2,4x,5i2,4x,i10,a80)

      time_int = 0
ccc    (ACTUALLY: we need to think about/clarify the meaning of iclk0 in
ccc       binary data files!!!!!)
      sampfreq = 1./dr
      return
      end
c______________________________________________________________________
c
      subroutine rdblk(npts,ix,ierr,nch)

!      include 'iounits.inc'
!      include 'input.inc'
!      include '../include/datsz.inc'
      use iounits_inc
      use input_inc
      use datsz_inc
      use FORMIN_common

      parameter(nmx = nblk*nchmx)

c     BINARY TWO BYTE INTEGER VERSION

      integer*4 ix4(nmx)
      integer*2 ix2(nmx)
      integer ix(0:nch,*),it1,npts,ix0(nchmx),msval,ioff,ierr  !itf,ioin,
     &   ,iscl(nchmx)
!      common /FORMIN/irec,irecl

	msval = 2147483647       ! TH:  defined here once more, = 2**31-1

      n = nch*nblk
      irec = irec + 1
      IDummy = irec

c     depending on BYTES read into an integer*2 or integer*4 array
      if (bytes .eq.2) then
         read(in_unit,rec=irec,err=99) it1,nt,(ix0(j),iscl(j),j=1,nch),
     &        (ix2(k),k=1,n)
      elseif (bytes .eq .4) then
         read(in_unit,rec=irec,err=99) it1,nt,(ix0(j),iscl(j),j=1,nch),
     &        (ix4(k),k=1,n)
      endif

      print *,'rdblk: irec, it1, nt =', idummy,it1,nt
      
      if(lfirst) then
         nmiss = 0
      else
         nmiss = it1 - itf
         if(nmiss.lt.0) then
            ierr = -2
            return
         end if
         if(nmiss .gt. nmsmx) then
            ierr = -3
            nmiss = 0
         end if
      end if

      do i = 1,nmiss
      ix(0,i) = itf - 1 + i + ioff
         do j = 1,nch
            ix(j,i) = msval
         enddo
      enddo

      npts = nt + nmiss
      do i = 1,nt
         ix(0,i+nmiss) = i -1 + it1 + ioff
         jj = nch*(i-1)
         do j = 1,nch
            if (bytes .eq .2) then
               ix(j,i+nmiss) = ix0(j) + iscl(j)*ix2(jj+j)
            elseif (bytes .eq. 4) then
               ix(j,i+nmiss) = ix0(j) + iscl(j)*ix4(jj+j)
            endif
         enddo
      enddo

      itf = ix(0,npts) + 1 - ioff
      ierr = 0

      return                              

99    continue
      ierr = -1
      return
      end
c___________________________________________________________
c
      function iclong(croot,n)
ccc   find positon of last non-blank characters in a string
ccc    (i.e., end of string, hopefully)
      character*1 croot(n)
      integer iclong
      do 10 i = n,1,-1
      if(ichar(croot(i)).ne.32) then
         iclong = i
         return
      end if
10    continue
      iclong = 0
      return
      end

c___________________________________________________________
c
      function icfirst(croot,n)
ccc   find number of blank characters at begining of a string
      integer icfirst
      character*1 croot(n)
      do 10 i = 1,n
      if(ichar(croot(i)).ne.32) then
         icfirst = i
         return
      end if
10    continue
      icfirst = n
      return
      end
c___________________________________________________________
c
      function irlong(cstr,n)
ccc   find number of characters before first '.' or ' ' in a string
      integer irlong
      character*1 cstr(n)
      do 10 i = 1,n
      if((cstr(i).eq.' ').or.(cstr(i).eq.'.')) then
         irlong = i-1
         return
      end if
10    continue
      irlong = n
      return
      end
c______________________________________________________________________
c
      subroutine NIMSbinInit(msval,nch)

ccc   NIMSbinInit  reads in clock reset information (time of zero record +
ccc    time of universal clock zero), and sets up sample numbering for
ccc    NIMS binary data files ... also reads in missing value code
ccc    File should be opened as direct access, record length = 4 bytes

!      include 'iounits.inc'
!      include 'input.inc'
      use iounits_inc
      use input_inc
      use FORMIN_common

      integer mday(12)
      data mday/31,28,31,30,31,30,31,31,30,31,30,31/

!      integer irec
      integer igap(3)
      integer nch,headerLength

!      common/FORMIN/irec,irecl

c     only allows for 5 channels
      nch = 5

c     style of binary file: blocked time series reading,
c               or point-by-point?
      read(in_unit,rec=1,err=99) headerLength
      if(headerLength .eq. (256*nch-3)*4) then     !TH orig: (256*nch-3)*4
         irecl = 256*nch          !TH  orig = 256*nch*4 
      else
         irecl = 1                  !TH  orig  = 4
      endif

c     sampling interval
      read(in_unit,rec=5)  dr

c     INSTRUMENT CLOCK ZERO TIME - year month, day, time (ut)
c        [ hour,min,sec] (i.e., the time of the first record in the file)
      read(in_unit,rec=7)  iyr
      read(in_unit,rec=8)  imo
      read(in_unit,rec=9)  iday
      read(in_unit,rec=10)  ihr
      read(in_unit,rec=11)  imin
      read(in_unit,rec=12)  isec

ccc   UNIVERSAL CLOCK ZERO TIME - year month, day, time (ut)
ccc       [ hour,min,sec] ( i.e., reference time for synchronizing stations)
      read(in_unit,rec=13)  iyru
      read(in_unit,rec=14)  imou
      read(in_unit,rec=15)  idayu
      read(in_unit,rec=16)  ihru
      read(in_unit,rec=17)  iminu
      read(in_unit,rec=18)  isecu

ccc   use clock reset info to set sample numbering for data in ASCII file
ccc    compute julian day number for instrument clock zero (relative to
ccc    start of year for universal clock zero)
      jday = 0
      do i = iyru,iyr-1
         if(mod(i,4).eq.0) then
            jday = jday+366
         else
            jday = jday+365
         endif
      enddo

      do i = 1,imo-1
         if( (mod(iyr,4).eq.0) .and. (i.eq.2) ) then
            jday = jday+mday(i) + 1
         else
            jday = jday + mday(i)
         end if
      enddo
      jday = jday + iday

ccc   compute julian day number for universal clock zero (relative to
ccc      start of year for universal clock zero)
      jdayu = 0
      do i = 1,imou-1
         if( (mod(iyru,4).eq.0) .and. (i.eq.2) ) then
            jdayu = jdayu+mday(i) + 1
         else
            jdayu = jdayu + mday(i)
         end if
      enddo
      jdayu = jdayu + idayu

ccc   record number (relative to universal clock zero) of first record in file
      jday = jday-jdayu
      ihr = ihr - ihru
      imin = imin - iminu
      isec = isec - isecu

      time_int = ((jday*24+ihr)*60+imin)
      time_int = time_int*60+isec
      sampfreq = 1./dr

ccc   read number of data total
      read(in_unit,rec=19) nscans
      write(0,*) 'nscans = ',nscans

ccc   read missing data flag
      read(in_unit,rec=21) msval
      write(0,*) 'msval = ',msval

ccc   read number of gaps
      read(in_unit,rec=22) ngaps
      write(0,*) 'ngaps = ',ngaps
      if(ngaps .gt. 0) then
          write(0,*) 'Warning: there are ',ngaps,' data gaps'
          ii = 22
          do i = 1,ngaps
             read(in_unit,rec=ii+1) igap(1)
             read(in_unit,rec=ii+2) igap(2)
             read(in_unit,rec=ii+3) igap(3)
             write(0,*) 'mk_off: igap=',igap
             ii = ii + 3
          enddo
       endif          

ccc   set record number in bin file for first data read
      irec = 24+3*ngaps
      itf = 1
      ierr_bin_read = 0

      return
99    ierr_bin_read = -1
      return
      end
c______________________________________________________________________
c
      subroutine rdblkNIMSbin(npts,ix,ierr,nch)

!      include 'iounits.inc'
!      include 'input.inc'
!      include '../include/datsz.inc'
      use iounits_inc
      use input_inc
      use datsz_inc
      use FORMIN_common

      parameter(nmx = nblk*nchmx)

c     NIMS binary versions 
c               (reads binary file output by Booker's nimsread)

      integer*4 ix4(nmx)
      integer ix(0:nch,*),it1,npts,ix0(nchmx),msval,ioff,ierr !itf
!      common /FORMIN/irec,irecl

c     if data gaps are present (ngaps > 0 in nimsread output)
c             this code will need to be changed
      if(irecl .eq. 1) then             !TH  orig: (irecl .eq. 4)
         do k = 1,nblk
            ix(0,k) = itf + ioff
            do j = 1,nch
               irec = irec + 1
               read(in_unit,rec=irec,err=99) ix(j,k)
            enddo
            itf =itf+1
         enddo
      else
!         write(6,*) 'NEVER COME HERE irec, irecl',irec,irecl  !TH test = cygwin

      ioff = 0  !TH test cygwin produces ioff=0, but in reallity it is undefined
                ! seting explicit =0 produces same zss as from cygwin
      write(6,*) 'rdblkNIMS: irec, irecl, itf,ioff',irec,irecl,itf,ioff  !TH test
         irec = irec +1
         read(in_unit,rec=irec,err=99) ((ix(j,k),j=1,nch),k=1,nblk)
 !        ioff = 0   !TH test if set to zero same resukts as cygwin
         do k = 1,nblk
            ix(0,k) = itf + ioff
            itf =itf+1
         enddo
      endif
      npts = nblk
      ierr = 0
      return                              

99    continue
      if(irecl .eq. 4) then
          npts = k-1
      else
          npts = 0
      endif
      ierr = -1
      return
      end

!     subroutines to read KMS binary files

      SUBROUTINE KMSbinInit(msval,nch1)
!     initialization of reading KMS binary data and get the time      

!ccc   KMSbinInit  reads in clock reset information (time of zero record +
!ccc    time of universal clock zero), and sets up sample numbering for
!ccc    KMS binary data files 
!ccc    File should be opened as direct access, record length = 1

!      include 'iounits.inc'
!      include 'input.inc'
      use iounits_inc
      use input_inc
      use FORMIN_common
      use SD_param
      use SD_file_parameters

      IMPLICIT NONE
      INTEGER  :: msval,nch1
!     local variables      
      INTEGER, DIMENSION(12)    :: mday
      CHARACTER(LEN=32)   :: string,cstring
      REAL*8              :: R8num,ss,ssu
      REAL*8              :: latitude,longitude,time,first_sample_time
      REAL*8              :: sigmaAD
      INTEGER*4, EXTERNAL :: in32Endian
      INTEGER*8, EXTERNAL :: in64Endian
      INTEGER*8, EXTERNAL :: unsign4
      INTEGER*8           :: first_sample_acq_time
      INTEGER*8           :: large_first_1,large_first_2
      INTEGER*8, PARAMETER:: large_factor = 214783648
      INTEGER             :: i, iunit
      INTEGER             :: iyr, imo, iday, ihr, imin, isec, jday   ! date time 
      INTEGER             :: iyru,imou,idayu,ihru,iminu,isecu,jdayu  ! reference date time
      INTEGER             :: ii, nbytes4, len_string, nchan
      REAL                :: yeardate,glat_d,glon_d,glat_m,glon_m
      INTEGER             :: idum1,idum2
      CHARACTER(LEN=1), DIMENSION(8)  :: char_string_SD
      CHARACTER(LEN=64)               :: char_string, char_string_rev
      INTEGER, DIMENSION(6)           :: ch_enable,ich_enable
      CHARACTER(LEN=1)                :: glon_c,glat_c,dum1

      
!      LOGICAL             :: Lcheck = .true.
      
      data mday/31,28,31,30,31,30,31,31,30,31,30,31/


!      common/FORMIN/irec,irecl
!     executable statements
!c     only allows for 5 channels
!      nch1 = 5    ! see end of subroutine
!      iunit = 8 

      print *,'INITIALIZATION'      
 
      READ(in_unit,rec=1,ERR=99) SD_H     ! read first header for GPS position and timing

      nbytes_header = 2*nbytes_page     ! number of bytes in header default 2*512
      nbytes_data = 
     &       unsign4(in32Endian(SD_H%num_of_data_bytes_per_headers))
     
      write(6,'(A17,I3)')
     & 'firmware version=',ichar(SD_H%firmware_version)
      write(6,'(A17,I3)')'fpga     version=',ichar(SD_H%fpga_version)

      print *,'num_of_data_bytes_per_headers',nbytes_data
      
      if (nbytes_data == 65537) then      ! the case for test1.bin example
          nbytes_data = 90*nbytes_page    ! default = 90*512
      endif    
      if (nbytes_data == 0) then
          nbytes_data = 90*nbytes_page    ! default = 90*512
      endif    
      if (ichar(SD_H%fpga_version) < 64) then
           nbytes_data = 90*nbytes_page    ! default = 90*512 old file header
      endif
      nbytes_packet = nbytes_header + nbytes_data   
    
      print *,'nbytes_data  ',nbytes_data
      print *,'nbytes_header',nbytes_header
      print *,'nbytes_packet',nbytes_packet


!     sampling frequency and sampling interval
      sampfreq = unsign4(in32Endian(SD_H%sampling_frequency))
      print *,'Sample Freq',sampfreq
      if (sampfreq .eq. 62.) then
          sampfreq = 62.5
      endif
      dr = 1./sampfreq
!      print *,'sampling frequency (Hz):',sampfreq
      
      string(1:21) = SD_H%GPS_time_info(4:24)     ! date
      read(string,'(i2,i2,f6.3,1x,i2,1x,i2,1x,i4)')
     &  ihr,imin,ss,iday, imo,iyr
!      print *,'ihr,imin,ss,iday,imo,iyr',ihr,imin,ss,iday,imo,iyr
      ss = int(ss)             ! fractional part in seconds is not used by John
      string(1:8) = SD_H%GPS_syn_clk(1:8)         ! get sync. clock in MHz
!      print *,"GPS_syn_clk",SD_H%GPS_syn_clk(1:8)
      read(string(1:8),*) r8num
!      print *,'r8num',r8num


!     get time delay
      
!          large_first_1 = in32Endian(SD_H%first_sample_acq_time1)
!!          print *,"large 1",large_first_1
!          large_first_2 = in32Endian(SD_H%first_sample_acq_time2)
!!          print *,"large 1",large_first_2
!       first_sample_acq_time =large_first_1*large_factor + large_first_2
!      first_sample_time = dfloat(first_sample_acq_time)*1.d-6/r8num

       first_sample_time =dfloat(in64Endian(SD_H%first_sample_acq_time))
!       print *,'integer first_sample_time',first_sample_time
       first_sample_time = first_sample_time*1.d-6/r8num   ! in seconds
       first_sample_time = first_sample_time + 1.d0  ! info from john plus 1 second
       If (sampfreq == 1000 .or. sampfreq .eq. 4000) then
           sigmaAD = 38.d0/dble(sampfreq)
       else
           sigmaAD = 39.d0/dble(sampfreq)
       endif                  
       first_sample_time = first_sample_time - sigmaAD
      
      ss = ss + first_sample_time      ! add delay plus 1 extra second (from John)
      print *,'seconds+delay',ss, ss/60.
      

!c     INSTRUMENT CLOCK ZERO TIME - year month, day, time (ut)
!c        [ hour,min,sec] (i.e., the time of the first record in the file)
!      read(in_unit,rec=7)  iyr
!      read(in_unit,rec=8)  imo
!      read(in_unit,rec=9)  iday
!      read(in_unit,rec=10)  ihr
!      read(in_unit,rec=11)  imin
!      read(in_unit,rec=12)  isec

!ccc   UNIVERSAL CLOCK ZERO TIME - year month, day, time (ut)
!ccc       [ hour,min,sec] ( i.e., reference time for synchronizing stations)
      iyru = iyr         ! here beginning of the year for frequencies <= 1kHz
      imou = 1           ! January
      if (sampfreq .gt. 1000.) then ! for high frequency change reference time
          imou = imo                          ! reference
          if (imou .gt. 1) imou = imou - 1       ! reference is previous month
      endif    
      idayu = 1
      ihru = 0
      iminu = 0
      ssu = 0.                                         !isecu
      if (sampfreq .ge. 40000) then
!        for high sampling frequency no reference time    
         iyru = iyr
         imou = imo  
         idayu = iday
         ihru = 0
         iminu = 0
         ssu = 0                                         !isecu
      endif

!ccc   use clock reset info to set sample numbering for data in ASCII file
!ccc    compute julian day number for instrument clock zero (relative to
!ccc    start of year for universal clock zero)
      jday = 0
      do i = iyru,iyr-1
         if(mod(i,4).eq.0) then
            jday = jday+366
         else
            jday = jday+365
         endif
      enddo

      do i = 1,imo-1
         if( (mod(iyr,4).eq.0) .and. (i.eq.2) ) then
            jday = jday+mday(i) + 1
         else
            jday = jday + mday(i)
         end if
      enddo
      jday = jday + iday

!ccc   compute julian day number for universal clock zero (relative to
!ccc      start of year for universal clock zero)
      jdayu = 0
      do i = 1,imou-1
         if( (mod(iyru,4).eq.0) .and. (i.eq.2) ) then
            jdayu = jdayu+mday(i) + 1
         else
            jdayu = jdayu + mday(i)
         end if
      enddo
      jdayu = jdayu + idayu

!ccc   record number (relative to universal clock zero) of first record in file
      jday = jday-jdayu
      ihr = ihr - ihru
      imin = imin - iminu
      ss = ss - ssu    ! attention
      print *,'jday,ihr,imin,ss',jday,ihr,imin,ss

      time_int = ((jday*24+ihr)*60+imin)
!      time_int = time_int*60 + int(ss)  ! in seconds  isec
!      time_int = time_int*60*1000 +  int(ss*1000)  !  in milli seconds 
      
      time_int = time_int*60*1000000 +  dint(dble(ss*1000000.))  !  in micro seconds 
!      time_int = 0

      print *,'time_int (us)',time_int
      
      itf = 0                          ! time sample counter start
      irec = 0
      ierr_bin_read = 0
      msval = 2147483647                ! no missing data

!     get number of enabled channels from header
      nbytes4 = 4
      char_string_SD(1:4) = SD_H%AD_ctrl_word(1:4)
      call get_BitSeq(nbytes4,char_string_SD,char_string,len_string)

      do i=1,len_string   ! reverse is easier to compare with bit position
         char_string_rev(len_string-i+1:len_string-i+1)=char_string(i:i)
      enddo

   !   char_string_rev(4:5) = '00'

      nchan = 0
      do i=1,6
          SELECT CASE (char_string_rev(i:i))
          CASE ("0") 
             ch_enable(i) = 0
!             write(6,'(A5,i2,A12)') "Chan(",i," )  disabled"
          CASE ("1")
             nchan = nchan + 1 
             ch_enable(i) = 1
             ich_enable(nchan) = i
 !            write(6,'(A5,i2,A11)') "Chan(",i," )  enabled"
          END SELECT
      enddo   
      nch1 = nchan
      
      
      
!       GPS positions
        cstring = SD_H%GPS_pos_info
!        print *,'cstring GPS =',cstring
        READ(cstring,110) idum1,glat_m,idum2,glon_m   ! splitting needed
c  110   FORMAT(I2,F11.6,3x,i2,F12.6)   
  110   FORMAT(I2,F11.6,2x,i3,F12.6)   !corrected BRL
        READ(cstring,115) glat_c,glon_c
  115   FORMAT(T13,A1,T28,A1)
!        hat zahlen richtig gelesen aber nicht die beiden characters
!        READ(cstring,110) idum1,glat_m,glat_c,idum2,glon_m,glon_c
!  110   FORMAT(I2,F11.6,1x,a1,1x,i2,F12.6,1x,a1)   
!        print '(A,2F12.6)','glat_m,glon_m',glat_m,glon_m
!        print *,'idum1,idum2',idum1,idum2     
        glat_d = float(idum1) + glat_m/60.
        if(glat_c .eq. 'S') glat_d = -glat_d
        glon_d = float(idum2) + glon_m/60.
        if(glon_c .eq. 'W') glon_d = -glon_d
!        print *,'glat_c',glat_c   
!        print *,'glon_c',glon_c   
           

c       magnetic declination of station
        MagnetDecl = 0.0                            ! default
        string(1:21) = SD_H%GPS_time_info(4:24)     ! date
        read(string,'(i2,i2,f6.3,1x,i2,1x,i2,1x,i4)')
     &  ihr,imin,ss,iday, imo,iyr
!       print *,'ihr,imin,ss,iday,imo,iyr',ihr,imin,ss,iday,imo,iyr
        yeardate = float(iyr) + float(imo)/12.
        Call calc_MagnDecl (glat_d,glon_d,yeardate,MagnetDecl)
cew       call calc_magnDecl (glat_d,glon_d,yeardate,MagnetDecl)  ! magnetic declination
!        print *,'glat_d',glat_d
!        print *,'glon_d',glon_d
!        print *,'year  ',yeardate
!        print *,'from KMSbinInit: magnetic declination=',MagnetDecl


      RETURN
99    ierr_bin_read = -1
      RETURN
      END SUBROUTINE KMSbinInit
      
      SUBROUTINE rdblkKMS(npts,xdata,ierr,nch,nchmx1)  !,nch_enabled,irec)
!     reads KMS binary data in blocks of nblk (dnff)
!     definition statements
      use iounits_inc
      use input_inc
      use datsz_inc
      use FORMIN_common
      use SD_param

      IMPLICIT NONE
      INTEGER, INTENT(OUT)    :: npts   ! number of points which have been actially read (max. nblk)
      REAL, DIMENSION(nchmx1,*), INTENT(OUT)       :: xdata  ! array (nch+1,nblk ) of data, here (1,*) is time array
      INTEGER, INTENT(OUT)    :: ierr   ! error flag, indicate the end of data
      INTEGER, INTENT(IN)     :: nch    ! number of channels used in SP-file
      INTEGER, INTENT(IN)     :: nchmx1
!      INTEGER, INTENT(IN)     :: nch_enabled   ! actual # channels enabled in KMS820 
      
!     local variables
      REAL                    :: rpacket     ! number of packets with fraction at i-th block (irec)
      INTEGER                 :: ipacket     ! number of complet packets
      INTEGER                 :: ifract      ! fractional part of a packet
      INTEGER                 :: ipos_rec    ! position of first sample in block in units of bytes
!!      INTEGER*1, DIMENSION(256*3*6)  :: i1data    ! array for reading 24 bit data in block
      INTEGER*1, DIMENSION(1024*3*6)  :: i1data    ! array for reading 24 bit data in block
      
      INTEGER                 :: ich, isample, ipos, i, k
      INTEGER                 :: io_stat
      INTEGER                 :: nch6,nch5
      REAL*4, EXTERNAL        :: conv24Bit   ! conversion of 24bit integer to Real number, also (LE to BE)
      
!     auxillary definitions for testing, will be later in modules
!      INTEGER                 :: nblk = 256
      INTEGER                 :: nbytes_blk != 256*3*6
!!      INTEGER                 :: nbytes_packet=91*512  !2560*3*6 +512
!      INTEGER                 :: nbytes_packet=92*512  !2560*3*6 + 2*512
!      INTEGER                 :: in_unit = 8
      INTEGER                 :: num_blk_per_packet   ! # blocks which fits in 1 packet
!      INTEGER                 :: itf               ! irec took out
      SAVE
!     execution statements      
      INTEGER i_stop
      
      nch6 = nch
      nch5 = nch
      if (nch .eq. 6) then
         nch6 = nch
         nch5 = 5
      endif
         
      nbytes_blk = nblk*3*nch6
      num_blk_per_packet = nbytes_data/3/nch6/nblk
      npts = 0       ! 

      irec = irec + 1                                ! counts # nblk-blocks in time series
!     print *,'num_blk_per_packet',num_blk_per_packet
!     find postion of irec-block in bytes for binary storage with direct access
      rpacket = FLOAT(irec)/FLOAT(num_blk_per_packet) 
      ipacket = (irec-1)/num_blk_per_packet          ! # packets already read in
!      ipacket = ipacket
      ifract  = MODULO(irec,num_blk_per_packet)    ! find i-th blk in actual packet
      if (ifract == 0) ifract = num_blk_per_packet   ! for the last block in a packet
      
!      ipos_rec = (ipacket-0)*nbytes_packet + (ifract-1)*nbytes_blk + 1 + 512   ! old file format
      ipos_rec = (ipacket-0)*nbytes_packet+(ifract-1)*nbytes_blk+1+1024  ! new file format
      
!      print *,'irec, ipacket, ifract',irec ,ipacket ,ifract
!      npts=0 !BRL
      if (ipos_rec.gt.665280512)then
          i_stop=0
      endif
      
      read (in_unit,rec=ipos_rec,iostat=io_stat,ERR=99) 
     &      (i1data(i),i=1,nbytes_blk)
      
      npts = nblk                        ! complete block has be read
   99 continue
      IF (io_stat /= 0) THEN  
!          print *,'rdblkKMS: error in reading io_stat = ',io_stat
          NPTS = (i-1)/3/nch6                     ! part of block has been read
          ierr = -1
          IF (NPTS == nblk) THEN
             NPTS = 0   ! no more data in block, npts is still
          ENDIF         ! from previous call = nblk, reset npts to zero
          print *,'End of binary reading.  flags: npts ierr',npts,ierr
      ENDIF    
      IF (NPTS == 0) THEN
        print *,'end of file reached, next block is empty'
        RETURN
      ENDIF  
      do isample=1,npts     !nsamples
          do ich=1,nch5
              ipos = (isample-1)*3*nch6 + (ich-1)*3 + 1  ! 6 ch enabled and no sorting
 !             ipos = (isample-1)*18 + (ich_enable(ich)-1)*3 + 1  
            xdata(ich+1,isample) = 
     &             conv24Bit(i1data(ipos),i1data(ipos+1),i1data(ipos+2))
!              xdata(indx_ch(ich),isample) = conv24Bit(i1data(ipos),i1data(ipos+1),i1data(ipos+2))
           enddo
 !       print *,'isample xdata',isample, xdata(2,isample),
  !   &   xdata(3,isample),ipos
       enddo
       
       do k = 1,npts            ! fill in time column with sample number
          xdata(1,k) = itf      !+ ioff  take out
          itf =itf+1            ! counts for sample number
       enddo
    !  print *,'xdata:',int(xdata(1,1)),(int(xdata(k,1)*3355.4432),k=2,6)
    !  print *,'xdata:',int(xdata(1,256)),
   !  &        (int(xdata(k,256)*3355.4432),k=2,6)
  
      RETURN
      END SUBROUTINE rdblkKMS

      
      FUNCTION in16Endian(iarg)
      INTEGER*2, INTENT(IN)  :: iarg
      INTEGER*2  :: in16Endian
!     local variable      
      INTEGER*2  :: irevers
      
      CALL MVBITS( iarg, 8, 8, irevers, 0 )
      CALL MVBITS( iarg, 0, 8, irevers, 8 )
      
      in16Endian = irevers
      return
      end  
      FUNCTION in32Endian(iarg)
      INTEGER*4, INTENT(IN)  :: iarg
      INTEGER*4  :: in32Endian
      INTEGER*4  :: idum
c      idum=0
      
      CALL MVBITS( iarg, 24, 8, idum, 0  )
      CALL MVBITS( iarg, 16, 8, idum, 8  )
      CALL MVBITS( iarg,  8, 8, idum, 16 )
      CALL MVBITS( iarg,  0, 8, idum, 24 )
      
      in32Endian = idum
      return
      end  
      FUNCTION in64Endian(iarg)
      INTEGER*8, INTENT(IN)  :: iarg
      INTEGER*8  :: in64Endian
      INTEGER*8  :: irevers
c      irevers=0
      
      CALL MVBITS( iarg, 56, 8, irevers, 0  )
      CALL MVBITS( iarg, 48, 8, irevers, 8  )
      CALL MVBITS( iarg, 40, 8, irevers, 16 )
      CALL MVBITS( iarg, 32, 8, irevers, 24 )
      CALL MVBITS( iarg, 24, 8, irevers, 32 )
      CALL MVBITS( iarg, 16, 8, irevers, 40 )
      CALL MVBITS( iarg,  8, 8, irevers, 48 )
      CALL MVBITS( iarg,  0, 8, irevers, 56 )
      
      in64Endian = irevers
      return
      end  
      
      FUNCTION unsign2(NARG)
!     convert interger*2 to unsigned integer as integer*4
      INTEGER*2, INTENT(IN)  :: NARG
      INTEGER*4 :: unsign2
!     executable 
      if (NARG .LT. 0) then
          unsign2 = 65536 + NARG   ! 2**16 + NARG
      else
          unsign2 = NARG
      endif          
      RETURN
      END       
      
      FUNCTION unsign4(NARG)
!     convert interger*2 to unsigned integer as integer*4
      INTEGER*4, INTENT(IN)  :: NARG
      INTEGER*8 :: unsign4
!     executable 
      if (NARG .LT. 0) then
celw          unsign4 = 4294967296 + NARG   ! 2**32 + NARG
          unsign4 = 2147483647 + NARG
	  else
          unsign4 = NARG
      endif          
      RETURN
      END       
      
      
      FUNCTION conv24bit(i1dum2,i1dum1,i1dum0)
!     convert 24 Bit (big endian) number to 4 byte number (little endian)
      IMPLICIT NONE     
      INTEGER*1 :: i1dum2,i1dum1,i1dum0  ! input parameters will be changed
      REAL*4 :: conv24bit
!     local varables      
      INTEGER*4 :: i4dum2,i4dum1,i4dum0,i4aux,i4dum4
      INTEGER*1 :: i1aux,i1aux2,i1aux1,i1aux0
      REAL*4, PARAMETER :: scale_mV = 2.980232239E-4  ! 2500/2**23 mV/Bits
      LOGICAL LfirstBit
!     first executable statement      
      if (btest(i1dum2,7)) then  ! check first bit
!                                first bit is 1 for negative number
          i1dum2 = NOT(i1dum2)   ! take comlentary number
          i1dum1 = NOT(i1dum1)   ! NOT was only applied succesfully on same variable name
          i1dum0 = NOT(i1dum0)
          LfirstBit = .true.     ! set negative number
      else
          LfirstBit = .false.    ! first bit is 0 for postive number        
      endif
      i4dum2 = i1dum2        ! tansfer from 1 byte to 4 byte number
      i4dum1 = i1dum1
      i4dum0 = i1dum0
   
           
      if(i1dum0 .lt. 0) then        ! check sign bit of 1 byte number
          i1aux = ibclr(i1dum0,7)   ! clear sign bit
          i4aux = i1aux
          i4dum0= ibset(i4aux,7)    ! set 1 to old position
      endif    
             
      if(i1dum1 .lt. 0) then        ! check sign bit of 1 byte number
          i1aux = ibclr(i1dum1,7)   ! clear sign bit
          i4aux = i1aux             ! swap to 4 bytes
          i4dum1= ibset(i4aux,7)    ! set 1 to old position
      endif    
!     stack 1byte numbers together with appropiate shift       
      i4dum4 = i4dum0 + ISHFT(i4dum1,8) + ISHFT(i4dum2,16) 

      if (LfirstBit) then           ! consider negative number
          i4dum4 = NOT(i4dum4)
      endif    
      conv24Bit = float(i4dum4)   !*scale_mV
      RETURN
      END FUNCTION conv24BIT
      
      
      
