C ME 	REMOVE SCRATCH FILE
c      subroutine outinit(iouout,ioscr,nch,cfout,lpack)
C ME 	REMOVE SCRATCH FILE
      subroutine outinit(nch,lpack)
cnew      character*80 cfout

!      include 'iounits.inc'
!      include '../include/four_byte.inc'
      use iounits_inc
      use l_4byte_inc

      logical lpack, filepresent
c       initialize for outputing packed record


C ME 	REMOVE SCRATCH FILE
c       open scratch file for temporary output of FCs
c      irlscr = 4*(2*nch+1)
c      if(l_4byte) irlscr = irlscr/4
c      open(file='f_scratch',unit=ioscr,form='unformatted',
c     &    access='direct',recl=irlscr)
C ME 	REMOVE SCRATCH FILE

      if (nch == 6) then
          print *,'out_pack warning: nch=',nch
          nch = 5
      endif


c        open file for output of ordered FCs
      if(lpack) then
         irecl = 4*(nch+1)
      else
         irecl = 4*(2*nch+1)
      end if
      if(l_4byte) irecl = irecl/4
      
      !see if file exists (BRL 2014)
      inquire(FILE=cfout, EXIST=filepresent)
      if (filepresent)then
          open(unit=out_unit,file=cfout,access='direct',
     &    form='unformatted',recl=irecl, STATUS='OLD')
          close(out_unit,STATUS='DELETE')
      end if
          
      open(unit=out_unit,file=cfout,access='direct',form='unformatted',
     &  recl=irecl)

      if(l_asc_FC) open(unit=45,file='fcoef.dat',status='unknown')    ! TH: check coeff 

      return
      end
c________________________________________________________________
c

C     ME	REMOVE SCRATCH FILE
c      subroutine mkseq(iouin,iouout,ifdir,iset,nsets,nch,
c     1  nd,cwrk,cout,nfmax,idoff,pspecl1,nchmx,nwmx,lpack,iwrk,ixs)
       subroutine mkseq(ifdir,iset,nsets,nch,
     1  nd,cwrk,cout,nfmax,idoff,pspecl1,nchmx,nwmx,lpack,iwrk,ixs,
     2     nsmax,x_scr, iuse_scr) 
        real x_scr(nsmax*nfmax,nchmx,2)
        integer iuse_scr(nsmax*nfmax)
C     ME	REMOVE SCRATCH FILE


c    overly complex, because it can treat the case of missing frequencies
c       makes sequential file ordered by frequency (i.e. all fourier
c       coefficients for a given frequency are adjacent, ordered by
c       set number)
      complex cwrk(nchmx,nsets),cout(nchmx,nsets)
      integer iset(4,nsets),ifdir(3,nsets),iwrk(nchmx,nsets),ixs(nsets)
      real pspecl1(nchmx,nwmx,*)
      logical lpack  !lhead,

!         write(0,*) 'nsets,nch,nd,nfmax,nsmax',nsets,nch,nd,nfmax,nsmax

      ireco = 20 
      do 50 id=idoff + 1,idoff + nd
c       set up; lrec  - last record for a set; ndr  - no. of sets for
c       decimation level id
         lrec=0
         ndr=0
         do 10 is=1,nsets
            irec=lrec+1
            lrec=lrec+ifdir(2,is)
            if(ifdir(1,is).ne.id) go to 10
            ndr=ndr+1
 
c       iset - for each set for decimation level id, iset contains:
c               1. set no.
c               2. frequency no.
c               3. last record read for this set - stored in cwrk
c               4. final record to read
            iset(4,ndr)=lrec
            iset(3,ndr)=irec
            iset(1,ndr)=ifdir(3,is)
C     ME 	REMOVE SCRATCH FILE
c            read(iouin,rec=irec) iset(2,ndr),(cwrk(k,ndr),k=1,nch)
        iset(2,ndr) = iuse_scr(irec)     ! SCRATCH FILE 02.01.98
        do k = 1,nch                                 ! SCRATCH FILE 02.01.98
        cwrk(k,ndr) = cmplx(x_scr(irec,k,1),x_scr(irec,k,2))     ! SCRATCH FILE 02.01.98
        enddo                                                        ! SCRATCH FILE 02.01.98

10          continue
 
c       sort file and output
        do 40 j=1,nfmax
           nf=0
           do 30 i=1,ndr
              if(iset(2,i).eq.j) then
                if(iset(3,i).le.iset(4,i)) then

                   nf=nf+1
c                  modified by GDE 5/21/2009 ; no rescaling of FCs in case lpack = .false.
                   if(lpack) then
                       do k = 1,nch
                          cout(k,nf) = cwrk(k,i)*1000/  
     &                                         pspecl1(k,j,id-idoff)
                       enddo
                   else
                       do k = 1,nch
                          cout(k,nf) = cwrk(k,i)
                       enddo
                   endif

                   ixs(nf) = iset(1,i)

                   if(iset(3,i).lt.iset(4,i)) then
c                    not done; read another record from set 
                       iset(3,i)=iset(3,i)+1
C     ME	REMOVE SCRATCH  FILE
c                       read(iouin,rec=iset(3,i)) iset(2,i),
c     &                               (cwrk(k,i),k=1,nch)
        i_scr_rec = iset(3,i)
        iset(2,i) = iuse_scr(i_scr_rec) 
        do k = 1,nch                  
           cwrk(k,i) = cmplx(x_scr(i_scr_rec,k,1),x_scr(i_scr_rec,k,2))
        enddo
C     ME	REMOVE SCRATCH  FILE

                    end if

                 end if
              end if
30            continue
           call pack(nch,nf,cout,ixs,j,id,ireco,
     &                      pspecl1(1,j,id-idoff),lpack,iwrk,nchmx)
40         continue
50       continue
      return
      end
c
c______________________________________________________________________
c
      subroutine pack(nch,nf,cout,ixs,ifreq,id,irec,pspecl1,
     &   lpack,ix,nchmx)

!      include 'iounits.inc'
      use iounits_inc
      
c    outputs both real and imaginary parts of complex fourier coefficients
c           packed into one four byte integer 

      parameter (minint = -2147483647)
cTH      real  cout(2,nch,nf),pspecl1(nch)    ! original
	real     pspecl1(nch)
      complex  cout(nchmx,nf)

      integer ix(nchmx,nf),nch,nf,id,irec,ixs(nf)
      logical lpack
 
      irec = irec + 1
      write(out_unit,rec=irec) id,ifreq,nf
      if(l_asc_FC) write(45,*) id,ifreq,nf                !TH: check
      irec = irec + 1

      write(out_unit,rec=irec) pspecl1
      if(l_asc_FC) write(45,*) pspecl1                     !TH: check

      if(lpack) then
         do 20 i=1,nf
         do 15 j=1,nch
cTH            xt1=cout(1,j,i)   ! original
cTH            xt2=cout(2,j,i)   ! original
            xt1=real (cout(j,i))
            xt2=aimag(cout(j,i))
	
               do 5 k=1,8
               if(abs(xt1).lt.(1.0)) go to 6
5              xt1=xt1/10.0
            ix(j,i)=minint
             write(34,*) 'id,ifreq,xt1,i,j = ',id,ifreq,xt1,i,j
            go to 15
6           k1=k-1
            l1=nint(4096*xt1-.5)
               do 10 k=1,8
               if(abs(xt2).lt.(1.0)) go to 11
10             xt2=xt2/10.0
            ix(j,i)=minint
             write(34,*) 'id,ifreq,xt1,i,j = ',id,ifreq,xt1,i,j
            go to 15
11          k2=k-1
            l2=nint(4096*xt2-.5)
            ix(j,i)=65536*(8*l2+k2)+32768+(8*l1+k1)
15          continue
20       continue


         do 25 i = 1,nf 
            irec = irec+1
            write(out_unit,rec=irec) ixs(i),(ix(j,i),j=1,nch)
c            write(*,*) ixs(i),(ix(j,i),j=1,nch)
c            read(*,'(a1)')value
25          continue
      else
         do 30 i = 1,nf
            irec = irec+1
            write(out_unit,rec=irec) 
     &           ixs(i),((cout(j,i)),j=1,nch)
c            write(*,*) 
c     &           ixs(i),((cout(j,i)),j=1,nch)
c            read(*,'(a1)')value
            
cTH     &           ixs(i),((cout(k,j,i),k=1,2),j=1,nch)
            if(l_asc_FC) write(45,'(I10,1p10E15.5)')  
     &           ixs(i),((cout(j,i)),j=1,nch)
cTH     &           ixs(i),((cout(k,j,i),k=1,2),j=1,nch)
30          continue
      end if
      return
      end
c______________________________________________________________________
c
      subroutine wfhead(nch,nd,nfreqmx,nwin,dr,idl
     1   ,chid,orient,decl,stcor,irlo)
 
!      include 'iounits.inc'
!      include '../include/nchmx.inc'
      use iounits_inc
      use nchmx_inc
      
      integer maxHeaderLength 
      parameter (maxHeaderLength = 20*(nchmx*8+4)) !880

      integer nwin(nd),idl(nd)
      real dr(nd),stcor(2),orient(2,nch),decl
      character*1 ctemp(maxHeaderLength)
      character*6 chid(nch)
      character*120 cr,cr1             ! TH: now same length as in cmove subroutine

ccc   ctemp of this size should allow for 100 channels + 20 decimation levels
      data ctemp/maxHeaderLength*' '/
 
      i1 = 1
      write(cr,101) nch
!      print*,'nch in header',nch
101   format('nch',i5)

      call cmove(ctemp,cr,8,i1)
 
      write(cr,102) nd
102   format('nd',i6)

      call cmove(ctemp,cr,8,i1)
  
      write(cr,103) nfreqmx 
103   format('nfmx',i4)

      call cmove(ctemp,cr,8,i1)      
      cr1='mwin'
      call cmove(ctemp,cr1,4,i1)
      do i = 1,nd
         write(cr,'(2i4)') idl(i),nwin(i)
         call cmove(ctemp,cr,8,i1)
      enddo
      
      cr1='dr   '          
      call cmove(ctemp,cr1,4,i1)
      do i = 1,nd
         write(cr,'(e12.4)') dr(i)
         call cmove(ctemp,cr,12,i1)    
      enddo

      cr1 = 'ch,orien'
      call cmove(ctemp,cr1,8,i1)
      do i = 1,nch
         write(cr,'(a6,f6.1)') chid(i),orient(1,i)
         call cmove(ctemp,cr,12,i1)
         write(cr,'(f8.2)') orient(2,i)
         call cmove(ctemp,cr,8,i1)
      enddo

      cr1 = 'scor'
      call cmove(ctemp,cr1,4,i1)
      write(cr,'(f8.4)') stcor(1)

      call cmove(ctemp,cr,8,i1)
      write(cr,'(f8.4)') stcor(2)

      call cmove(ctemp,cr,8,i1)
                  
      cr1 = 'decl'                 
      call cmove(ctemp,cr1,4,i1)
      write(cr,'(f8.4)') decl  

      call cmove(ctemp,cr,8,i1)

      do i = 1,20
         i1 = (i-1)*irlo + 1
         i2 = i1 + irlo-1
         write(out_unit,rec=i) (ctemp(j),j=i1,i2)
         if(l_asc_FC) write(45,*) (ctemp(j),j=i1,i2)           ! TH: check
      enddo

      return
      end
